#ifndef MSP_CRYPTO_HASH_H_
#define MSP_CRYPTO_HASH_H_

#include <string>

namespace Msp {
namespace Crypto {

class Hash
{
protected:
	Hash() { }
public:
	virtual ~Hash() { }

	virtual unsigned get_digest_size() const = 0;

	virtual void update(const char *, unsigned) = 0;
	virtual void update(const std::string &);
	virtual unsigned get_digest(char *, unsigned) const = 0;
	virtual std::string get_hexdigest() const;
};

} // namespace Crypto
} // namespace Msp

#endif
